rm(list=ls(all=TRUE))
#a=read.table("C:/Users/Penny/Dropbox/time series/new sim/linear/ar/AR20/coef20.txt")
#a=as.numeric(a)
n=50
require(VGAM)

arbootcompare=function(){
  temp=rep(0,(n+100))
  temp[1:20]=rnorm(20)
  e=rlaplace((n+100),0,1/sqrt(2))
  for (i in 1:(n-20+100)){
    temp[i+20]=.7*temp[i+10]-.1*temp[i]+e[i+20]
  }
  u=temp[101:(100+n)]
  
  fit=lm(u[-c(1:20)]~u[-c(1:19,n)]+u[-c(1:18,n-1:0)]+u[-c(1:17,n-2:0)]+u[-c(1:16,n-3:0)]+
           u[-c(1:15,n-4:0)]+u[-c(1:14,n-5:0)]+u[-c(1:13,n-6:0)]+u[-c(1:12,n-7:0)]+u[-c(1:11,n-8:0)]+
           u[-c(1:10,n-9:0)]+u[-c(1:9,n-10:0)]+u[-c(1:8,n-11:0)]+u[-c(1:7,n-12:0)]+u[-c(1:6,n-13:0)]+
           u[-c(1:5,n-14:0)]+u[-c(1:4,n-15:0)]+u[-c(1:3,n-16:0)]+u[-c(1:2,n-17:0)]+u[-c(1,n-18:0)]+
           u[-c(n-19:0)])
  fitcoef=fit$coef
  minroots <- min(Mod(polyroot(c(1, -fitcoef[-1]))))
  
  while (minroots <= 1) {
    temp=rep(0,(n+100))
    temp[1:20]=rnorm(20)
    e=rlaplace((n+100),0,1/sqrt(2))
    for (i in 1:(n-20+100)){
      temp[i+20]=.7*temp[i+10]-.1*temp[i]+e[i+20]
    }
    u=temp[101:(100+n)]
    fit=lm(u[-c(1:20)]~u[-c(1:19,n)]+u[-c(1:18,n-1:0)]+u[-c(1:17,n-2:0)]+u[-c(1:16,n-3:0)]+
             u[-c(1:15,n-4:0)]+u[-c(1:14,n-5:0)]+u[-c(1:13,n-6:0)]+u[-c(1:12,n-7:0)]+u[-c(1:11,n-8:0)]+
             u[-c(1:10,n-9:0)]+u[-c(1:9,n-10:0)]+u[-c(1:8,n-11:0)]+u[-c(1:7,n-12:0)]+u[-c(1:6,n-13:0)]+
             u[-c(1:5,n-14:0)]+u[-c(1:4,n-15:0)]+u[-c(1:3,n-16:0)]+u[-c(1:2,n-17:0)]+u[-c(1,n-18:0)]+
             u[-c(n-19:0)])
    fitcoef=fit$coef
    minroots <- min(Mod(polyroot(c(1, -fitcoef[-1]))))
  }
  
  e=fit$resid
  er=e-mean(e)
  sigmahat=sd(er)
  fvhat=sum(fitcoef[2:(21)]*u[n:(n-19)])+fitcoef[1]
  
  #predictive residuals
  resid=rep(0,(n-20))
  for(i in 1:(n-20)){
    tempfit=lm(u[-c(1:20,i+20)]~u[-c(1:19,i+19,n)]+u[-c(1:18,i+18,n-1:0)]+u[-c(1:17,i+17,n-2:0)]+
                 u[-c(1:16,i+16,n-3:0)]+u[-c(1:15,i+15,n-4:0)]+u[-c(1:14,i+14,n-5:0)]+u[-c(1:13,i+13,n-6:0)]+
                 u[-c(1:12,i+12,n-7:0)]+u[-c(1:11,i+11,n-8:0)]+u[-c(1:10,i+10,n-9:0)]+u[-c(1:9,i+9,n-10:0)]+
                 u[-c(1:8,i+8,n-11:0)]+u[-c(1:7,i+7,n-12:0)]+u[-c(1:6,i+6,n-13:0)]+u[-c(1:5,i+5,n-14:0)]+
                 u[-c(1:4,i+4,n-15:0)]+u[-c(1:3,i+3,n-16:0)]+u[-c(1:2,i+2,n-17:0)]+u[-c(1,i+1,n-18:0)]+
                 u[-c(i,n-19:0)])
    resid[i]=u[i+20]-sum(tempfit$coef[2:21]*u[i+19:0])-tempfit$coef[1]
  }
  res=resid-mean(resid)
  
  #################B&J#############################
  Bup=fvhat+qnorm(.975)*sigmahat
  Bdown=fvhat+qnorm(.025)*sigmahat
  Bl=Bup-Bdown
  Bup90=fvhat+qnorm(.95)*sigmahat
  Bdown90=fvhat+qnorm(.05)*sigmahat
  Bl90=Bup90-Bdown90
  
  bootstrap=function(residuals){
    bb=rep(0,(n+100))
    bb[1:20]=u[1:20]
    estar=sample(residuals,(n+101),replace=TRUE)
    for(i in 1:(81+n)){
      bb[i+20]=sum(fitcoef[2:21]*bb[i+19:0])+fitcoef[1]+estar[i+20]    
    }
    b=bb[101:(100+n)]
    fv=sum(fitcoef[2:21]*u[n:(n-19)])+fitcoef[1]+estar[(n+101)]
    fv1=bb[101+n]
    list(b=b,fv=fv,fv1=fv1)
  }
  
  FSfroot=rep(NA,1000)
  Mroot=rep(NA,1000)
  caofvstar=rep(NA,1000)
  sievefvstar=rep(NA,1000)
  Ffhat=rep(NA,1000)
  Ffstar=rep(NA,1000)
  for(i in 1:1000){
    result=bootstrap(er)
    ustar=result$b
    fitstar=lm(ustar[-c(1:20)]~ustar[-c(1:19,n)]+ustar[-c(1:18,n-1:0)]+ustar[-c(1:17,n-2:0)]+
                 ustar[-c(1:16,n-3:0)]+ustar[-c(1:15,n-4:0)]+ustar[-c(1:14,n-5:0)]+ustar[-c(1:13,n-6:0)]+
                 ustar[-c(1:12,n-7:0)]+ustar[-c(1:11,n-8:0)]+ustar[-c(1:10,n-9:0)]+ustar[-c(1:9,n-10:0)]+
                 ustar[-c(1:8,n-11:0)]+ustar[-c(1:7,n-12:0)]+ustar[-c(1:6,n-13:0)]+ustar[-c(1:5,n-14:0)]+
                 ustar[-c(1:4,n-15:0)]+ustar[-c(1:3,n-16:0)]+ustar[-c(1:2,n-17:0)]+ustar[-c(1,n-18:0)]+ustar[-c(n-19:0)])
    Ffhat[i]=sum(fitstar$coef[2:21]*u[n:(n-19)])+fitstar$coef[1]
    Ffstar[i]=result$fv
    sigmastar=sd(fitstar$resid)
    FSfroot[i]=(Ffstar[i]-Ffhat[i])/sigmastar#studentized bootstrap root
    Mhat=sum(fitstar$coef[2:21]*ustar[n:(n-19)])+fitstar$coef[1]
    Mstar=result$fv1
    Mroot[i]=(Mstar-Mhat)/sigmastar#M studentized bootstrap root
    caofvstar[i]=fvhat+sample(er,1)#cao
    sievefvstar[i]=sum(fitstar$coef[2:21]*u[n:(n-19)])+fitstar$coef[1]+sample(er,1)#sieve  
  }
  #preditive
  FSproot=rep(NA,1000)
  Fphat=rep(NA,1000)
  Fpstar=rep(NA,1000)
  for( i in 1:1000){
    result=bootstrap(res)
    ustar=result$b
    fitstar=lm(ustar[-c(1:20)]~ustar[-c(1:19,n)]+ustar[-c(1:18,n-1:0)]+ustar[-c(1:17,n-2:0)]+
                 ustar[-c(1:16,n-3:0)]+ustar[-c(1:15,n-4:0)]+ustar[-c(1:14,n-5:0)]+ustar[-c(1:13,n-6:0)]+
                 ustar[-c(1:12,n-7:0)]+ustar[-c(1:11,n-8:0)]+ustar[-c(1:10,n-9:0)]+ustar[-c(1:9,n-10:0)]+
                 ustar[-c(1:8,n-11:0)]+ustar[-c(1:7,n-12:0)]+ustar[-c(1:6,n-13:0)]+ustar[-c(1:5,n-14:0)]+
                 ustar[-c(1:4,n-15:0)]+ustar[-c(1:3,n-16:0)]+ustar[-c(1:2,n-17:0)]+ustar[-c(1,n-18:0)]+ustar[-c(n-19:0)])
    Fphat[i]=sum(fitstar$coef[2:21]*u[n:(n-19)])+fitstar$coef[1]
    Fpstar[i]=result$fv
    sigmastar=sd(fitstar$resid)
    FSproot[i]=(Fpstar[i]-Fphat[i])/sigmastar
  }
  
  backbootstrap=function(residuals){
    estar=sample(residuals,(n+101),replace=TRUE)
    wstar=rep(0,(n+100))
    wstar[1]=estar[1]-sum(fitcoef[2:21]*estar[2:21])
    for(i in 2:20){
      wstar[i]=sum(fitcoef[2:i]*wstar[(i-1):1])+estar[i]-sum(fitcoef[2:21]*estar[i+1:20])
    }
    #wstar[2]=fitcoef[2]*wstar[1]+estar[2]-sum(fitcoef[2:21]*estar[3:22])
    for(i in 21:(100+n)){
      wstar[i]=sum(fitcoef[2:21]*wstar[i-1:20])+estar[i]-sum(fitcoef[2:21]*estar[i+1:20])    
    }
    backerr=wstar[101:(100+n)]
    b=rep(0,n)
    b[n-19:0]=u[n-19:0]
    for(i in 20:(n-1)){
      b[n-i]=fitcoef[1]+sum(fitcoef[2:21]*b[n-i+1:20])+backerr[n-i]
    }
    fv=sum(fitcoef[2:21]*u[n:(n-19)])+fitcoef[1]+estar[n+101]
    list(b=b,fv=fv)
  }
  Bfstar=rep(NA,1000)
  Bfhat=rep(NA,1000)
  BSfroot=rep(NA,1000)
  for(i in 1:1000){
    result=backbootstrap(er)
    ustar=result$b
    fitstar=lm(ustar[-c(1:20)]~ustar[-c(1:19,n)]+ustar[-c(1:18,n-1:0)]+ustar[-c(1:17,n-2:0)]+
                 ustar[-c(1:16,n-3:0)]+ustar[-c(1:15,n-4:0)]+ustar[-c(1:14,n-5:0)]+ustar[-c(1:13,n-6:0)]+
                 ustar[-c(1:12,n-7:0)]+ustar[-c(1:11,n-8:0)]+ustar[-c(1:10,n-9:0)]+ustar[-c(1:9,n-10:0)]+
                 ustar[-c(1:8,n-11:0)]+ustar[-c(1:7,n-12:0)]+ustar[-c(1:6,n-13:0)]+ustar[-c(1:5,n-14:0)]+
                 ustar[-c(1:4,n-15:0)]+ustar[-c(1:3,n-16:0)]+ustar[-c(1:2,n-17:0)]+ustar[-c(1,n-18:0)]+ustar[-c(n-19:0)])
    Bfhat[i]=sum(fitstar$coef[2:21]*u[n:(n-19)])+fitstar$coef[1]
    Bfstar[i]=result$fv
    sigmastar=sd(fitstar$resid)
    BSfroot[i]=(Bfstar[i]-Bfhat[i])/sigmastar
  }
  Bpstar=rep(NA,1000)
  Bphat=rep(NA,1000)
  BSproot=rep(NA,1000)
  for(i in 1:1000){
    result=backbootstrap(res)
    ustar=result$b
    fitstar=lm(ustar[-c(1:20)]~ustar[-c(1:19,n)]+ustar[-c(1:18,n-1:0)]+ustar[-c(1:17,n-2:0)]+
                 ustar[-c(1:16,n-3:0)]+ustar[-c(1:15,n-4:0)]+ustar[-c(1:14,n-5:0)]+ustar[-c(1:13,n-6:0)]+
                 ustar[-c(1:12,n-7:0)]+ustar[-c(1:11,n-8:0)]+ustar[-c(1:10,n-9:0)]+ustar[-c(1:9,n-10:0)]+
                 ustar[-c(1:8,n-11:0)]+ustar[-c(1:7,n-12:0)]+ustar[-c(1:6,n-13:0)]+ustar[-c(1:5,n-14:0)]+
                 ustar[-c(1:4,n-15:0)]+ustar[-c(1:3,n-16:0)]+ustar[-c(1:2,n-17:0)]+ustar[-c(1,n-18:0)]+ustar[-c(n-19:0)])
    Bphat[i]=sum(fitstar$coef[2:21]*u[n:(n-19)])+fitstar$coef[1]
    Bpstar[i]=result$fv
    sigmastar=sd(fitstar$resid)
    BSproot[i]=(Bpstar[i]-Bphat[i])/sigmastar
  }
  #Masaroto
  Mdown=fvhat+quantile(Mroot,.025)*sigmahat
  Mup=fvhat+quantile(Mroot,.975)*sigmahat
  Ml=Mup-Mdown
  Mdown90=fvhat+quantile(Mroot,.05)*sigmahat
  Mup90=fvhat+quantile(Mroot,.95)*sigmahat
  Ml90=Mup90-Mdown90
  #FSf
  FSfdown=fvhat+quantile(FSfroot,.025)*sigmahat
  FSfup=fvhat+quantile(FSfroot,.975)*sigmahat
  FSfl=FSfup-FSfdown
  FSfdown90=fvhat+quantile(FSfroot,.05)*sigmahat
  FSfup90=fvhat+quantile(FSfroot,.95)*sigmahat
  FSfl90=FSfup90-FSfdown90
  #FSp
  FSpdown=fvhat+quantile(FSproot,.025)*sigmahat
  FSpup=fvhat+quantile(FSproot,.975)*sigmahat
  FSpl=FSpup-FSpdown
  FSpdown90=fvhat+quantile(FSproot,.05)*sigmahat
  FSpup90=fvhat+quantile(FSproot,.95)*sigmahat
  FSpl90=FSpup90-FSpdown90
  #BSf
  BSfdown=fvhat+quantile(BSfroot,.025)*sigmahat
  BSfup=fvhat+quantile(BSfroot,.975)*sigmahat
  BSfl=BSfup-BSfdown
  BSfdown90=fvhat+quantile(BSfroot,.05)*sigmahat
  BSfup90=fvhat+quantile(BSfroot,.95)*sigmahat
  BSfl90=BSfup90-BSfdown90
  #BSp
  BSpdown=fvhat+quantile(BSproot,.025)*sigmahat
  BSpup=fvhat+quantile(BSproot,.975)*sigmahat
  BSpl=BSpup-BSpdown
  BSpdown90=fvhat+quantile(BSproot,.05)*sigmahat
  BSpup90=fvhat+quantile(BSproot,.95)*sigmahat
  BSpl90=BSpup90-BSpdown90
  #cao
  caoup=quantile(caofvstar,.975)
  caodown=quantile(caofvstar,.025)
  Cl=caoup-caodown
  caodown90=quantile(caofvstar,.05)
  caoup90=quantile(caofvstar,.950)
  Cl90=caoup90-caodown90
  #sieve
  sieveup=quantile(sievefvstar,.975)
  sievedown=quantile(sievefvstar,.025)
  Sl=sieveup-sievedown
  sievedown90=quantile(sievefvstar,.05)
  sieveup90=quantile(sievefvstar,.950)
  Sl90=sieveup90-sievedown90
  #Ff
  Ffdown=fvhat+quantile(Ffstar-Ffhat,.025)
  Ffup=fvhat+quantile(Ffstar-Ffhat,.975)
  Ffl=Ffup-Ffdown
  Ffdown90=fvhat+quantile(Ffstar-Ffhat,.05)
  Ffup90=fvhat+quantile(Ffstar-Ffhat,.950)
  Ffl90=Ffup90-Ffdown90
  #Fp
  Fpdown=fvhat+quantile(Fpstar-Fphat,.025)
  Fpup=fvhat+quantile(Fpstar-Fphat,.975)
  Fpl=Fpup-Fpdown
  Fpdown90=fvhat+quantile(Fpstar-Fphat,.05)
  Fpup90=fvhat+quantile(Fpstar-Fphat,.950)
  Fpl90=Fpup90-Fpdown90
  #Bf
  Bfdown=fvhat+quantile(Bfstar-Bfhat,.025)
  Bfup=fvhat+quantile(Bfstar-Bfhat,.975)
  Bfl=Bfup-Bfdown
  Bfdown90=fvhat+quantile(Bfstar-Bfhat,.05)
  Bfup90=fvhat+quantile(Bfstar-Bfhat,.950)
  Bfl90=Bfup90-Bfdown90
  #Bp
  Bpdown=fvhat+quantile(Bpstar-Bphat,.025)
  Bpup=fvhat+quantile(Bpstar-Bphat,.975)
  Bpl=Bpup-Bpdown
  Bpdown90=fvhat+quantile(Bpstar-Bphat,.05)
  Bpup90=fvhat+quantile(Bpstar-Bphat,.950)
  Bpl90=Bpup90-Bpdown90
  
  truevalue=rep(0,1000)
  for (i in 1:1000){
    truevalue[i]=.7*u[n-9]-.1*u[n-19]+rlaplace(1,0,1/sqrt(2))
  }
  
  B=0; C=0;S=0;M=0;FSf=0;FSp=0;BSf=0;BSp=0;Ff=0;Fp=0;Bf=0;Bp=0
  B90=0; C90=0;S90=0;M90=0;FSf90=0;FSp90=0;BSf90=0;BSp90=0;Ff90=0;Fp90=0;Bf90=0;Bp90=0
  
  
  for (i in 1:1000){
    if((truevalue[i]<Bup) & truevalue[i]>Bdown)
      B=B+1
    if((truevalue[i]<caoup) & truevalue[i]>caodown)
      C=C+1
    if((truevalue[i]<sieveup) & truevalue[i]>sievedown)
      S=S+1
    if((truevalue[i]<Mup) & truevalue[i]>Mdown)
      M=M+1 
    if((truevalue[i]<Ffup) & truevalue[i]>Ffdown)
      Ff=Ff+1
    if((truevalue[i]<Fpup) & truevalue[i]>Fpdown)
      Fp=Fp+1
    if((truevalue[i]<Bfup) & truevalue[i]>Bfdown)
      Bf=Bf+1
    if((truevalue[i]<Bpup) & truevalue[i]>Bpdown)
      Bp=Bp+1
    if((truevalue[i]<FSfup) & truevalue[i]>FSfdown)
      FSf=FSf+1
    if((truevalue[i]<FSpup) & truevalue[i]>FSpdown)
      FSp=FSp+1
    if((truevalue[i]<BSfup) & truevalue[i]>BSfdown)
      BSf=BSf+1
    if((truevalue[i]<BSpup) & truevalue[i]>BSpdown)
      BSp=BSp+1
    
    if((truevalue[i]<Bup90) & truevalue[i]>Bdown90)
      B90=B90+1
    if((truevalue[i]<caoup90) & truevalue[i]>caodown90)
      C90=C90+1
    if((truevalue[i]<sieveup90) & truevalue[i]>sievedown90)
      S90=S90+1
    if((truevalue[i]<Mup90) & truevalue[i]>Mdown90)
      M90=M90+1
    if((truevalue[i]<Ffup90) & truevalue[i]>Ffdown90)
      Ff90=Ff90+1
    if((truevalue[i]<Fpup90) & truevalue[i]>Fpdown90)
      Fp90=Fp90+1
    if((truevalue[i]<Bfup90) & truevalue[i]>Bfdown90)
      Bf90=Bf90+1
    if((truevalue[i]<Bpup90) & truevalue[i]>Bpdown90)
      Bp90=Bp90+1
    if((truevalue[i]<FSfup90) & truevalue[i]>FSfdown90)
      FSf90=FSf90+1
    if((truevalue[i]<FSpup90) & truevalue[i]>FSpdown90)
      FSp90=FSp90+1
    if((truevalue[i]<BSfup90) & truevalue[i]>BSfdown90)
      BSf90=BSf90+1
    if((truevalue[i]<BSpup90) & truevalue[i]>BSpdown90)
      BSp90=BSp90+1
  }
  Bc=B/1000;Cc=C/1000;Sc=S/1000;Mc=M/1000;Ffc=Ff/1000;Fpc=Fp/1000;Bfc=Bf/1000;Bpc=Bp/1000;FSfc=FSf/1000;FSpc=FSp/1000;BSfc=BSf/1000;BSpc=BSp/1000;
  Bc=B/1000;Cc=C/1000;Sc=S/1000;Mc=M/1000;Ffc=Ff/1000;Fpc=Fp/1000;Bfc=Bf/1000;Bpc=Bp/1000;FSfc=FSf/1000;FSpc=FSp/1000;BSfc=BSf/1000;BSpc=BSp/1000;
  Bc90=B90/1000;Cc90=C90/1000;Sc90=S90/1000;Mc90=M90/1000;
  Ffc90=Ff90/1000;Fpc90=Fp90/1000;Bfc90=Bf90/1000;Bpc90=Bp90/1000;FSfc90=FSf90/1000;FSpc90=FSp90/1000;BSfc90=BSf90/1000;BSpc90=BSp90/1000
  list(Bc=Bc,Cc=Cc,Sc=Sc,Mc=Mc,Ffc=Ffc,Fpc=Fpc,Bfc=Bfc,Bpc=Bpc,FSfc=FSfc,FSpc=FSpc,BSfc=BSfc,BSpc=BSpc,
       Bc90=Bc90,Cc90=Cc90,Sc90=Sc90,Mc90=Mc90,Ffc90=Ffc90,Fpc90=Fpc90,Bfc90=Bfc90,Bpc90=Bpc90,FSfc90=FSfc90,FSpc90=FSpc90,BSfc90=BSfc90,BSpc90=BSpc90,
       Bl=Bl,Cl=Cl,Sl=Sl,Ml=Ml,Ffl=Ffl,Fpl=Fpl,Bfl=Bfl,Bpl=Bpl,FSfl=FSfl,FSpl=FSpl,BSfl=BSfl,BSpl=BSpl,
       Bl90=Bl90,Cl90=Cl90,Sl90=Sl90,Ml90=Ml90,Ffl90=Ffl90,Fpl90=Fpl90,Bfl90=Bfl90,Bpl90=Bpl90,FSfl90=FSfl90,FSpl90=FSpl90,BSfl90=BSfl90,BSpl90=BSpl90)
}

Bc=rep(NA,500);Cc=rep(NA,500);Sc=rep(NA,500);Mc=rep(NA,500);
Ffc=rep(NA,500);Fpc=rep(NA,500);Bfc=rep(NA,500);Bpc=rep(NA,500);
FSfc=rep(NA,500);FSpc=rep(NA,500);BSfc=rep(NA,500);BSpc=rep(NA,500);
Bl=rep(NA,500);Cl=rep(NA,500);Sl=rep(NA,500);Ml=rep(NA,500);
Ffl=rep(NA,500);Fpl=rep(NA,500);Bfl=rep(NA,500);Bpl=rep(NA,500);
FSfl=rep(NA,500);FSpl=rep(NA,500);BSfl=rep(NA,500);BSpl=rep(NA,500);
Bc90=rep(NA,500);Cc90=rep(NA,500);Sc90=rep(NA,500);Mc90=rep(NA,500);
Ffc90=rep(NA,500);Fpc90=rep(NA,500);Bfc90=rep(NA,500);Bpc90=rep(NA,500);
FSfc90=rep(NA,500);FSpc90=rep(NA,500);BSfc90=rep(NA,500);BSpc90=rep(NA,500);
Bl90=rep(NA,500);Cl90=rep(NA,500);Sl90=rep(NA,500);Ml90=rep(NA,500);
Ffl90=rep(NA,500);Fpl90=rep(NA,500);Bfl90=rep(NA,500);Bpl90=rep(NA,500);
FSfl90=rep(NA,500);FSpl90=rep(NA,500);BSfl90=rep(NA,500);BSpl90=rep(NA,500);

for (i in 1:500){
  set.seed(5*i)
  results=arbootcompare()
  Bc[i]=results$Bc;Cc[i]=results$Cc;Sc[i]=results$Sc;Mc[i]=results$Mc;
  Ffc[i]=results$Ffc;Fpc[i]=results$Fpc;Bfc[i]=results$Bfc;Bpc[i]=results$Bpc;
  FSfc[i]=results$FSfc;FSpc[i]=results$FSpc;BSfc[i]=results$BSfc;BSpc[i]=results$BSpc;
  Bl[i]=results$Bl;Cl[i]=results$Cl;Sl[i]=results$Sl;Ml[i]=results$Ml;
  Ffl[i]=results$Ffl;Fpl[i]=results$Fpl;Bfl[i]=results$Bfl;Bpl[i]=results$Bpl;
  FSfl[i]=results$FSfl;FSpl[i]=results$FSpl;BSfl[i]=results$BSfl;BSpl[i]=results$BSpl;
  Bc90[i]=results$Bc90;Cc90[i]=results$Cc90;Sc90[i]=results$Sc90;Mc90[i]=results$Mc90;
  Ffc90[i]=results$Ffc90;Fpc90[i]=results$Fpc90;Bfc90[i]=results$Bfc90;Bpc90[i]=results$Bpc90;
  FSfc90[i]=results$FSfc90;FSpc90[i]=results$FSpc90;BSfc90[i]=results$BSfc90;BSpc90[i]=results$BSpc90;
  Bl90[i]=results$Bl90;Cl90[i]=results$Cl90;Sl90[i]=results$Sl90;Ml90[i]=results$Ml90;
  Ffl90[i]=results$Ffl90;Fpl90[i]=results$Fpl90;Bfl90[i]=results$Bfl90;Bpl90[i]=results$Bpl90;
  FSfl90[i]=results$FSfl90;FSpl90[i]=results$FSpl90;BSfl90[i]=results$BSfl90;BSpl90[i]=results$BSpl90;
  save.image("C:/Users/Penny/Dropbox/time series/new sim/linear/ar/AR20/ar20lap50.RData")
  print(i)
}
print(mean(Bc));print(mean(Cc));print(mean(Sc));print(mean(Mc));print(mean(Ffc));print(mean(Fpc));
print(mean(Bfc));print(mean(Bpc));print(mean(FSfc));print(mean(FSpc));print(mean(BSfc));print(mean(BSpc));
print(mean(Bl));print(mean(Cl));print(mean(Sl));print(mean(Ml));print(mean(Ffl));print(mean(Fpl));
print(mean(Bfl));print(mean(Bpl));print(mean(FSfl));print(mean(FSpl));print(mean(BSfl));print(mean(BSpl));
print(sd(Bl));print(sd(Cl));print(sd(Sl));print(sd(Ml));print(sd(Ffl));print(sd(Fpl));
print(sd(Bfl));print(sd(Bpl));print(sd(FSfl));print(sd(FSpl));print(sd(BSfl));print(sd(BSpl));
print(mean(Bc90));print(mean(Cc90));print(mean(Sc90));print(mean(Mc90));print(mean(Ffc90));print(mean(Fpc90));
print(mean(Bfc90));print(mean(Bpc90));print(mean(FSfc90));print(mean(FSpc90));print(mean(BSfc90));print(mean(BSpc90));
print(mean(Bl90));print(mean(Cl90));print(mean(Sl90));print(mean(Ml90));print(mean(Ffl90));print(mean(Fpl90));
print(mean(Bfl90));print(mean(Bpl90));print(mean(FSfl90));print(mean(FSpl90));print(mean(BSfl90));print(mean(BSpl90));
print(sd(Bl90));print(sd(Cl90));print(sd(Sl90));print(sd(Ml90));print(sd(Ffl90));print(sd(Fpl90));
print(sd(Bfl90));print(sd(Bpl90));print(sd(FSfl90));print(sd(FSpl90));print(sd(BSfl90));print(sd(BSpl90));
